import pysam
samfile = pysam.AlignmentFile("/home/theo/dev/git/cnvCallerGPU/3544.bam", "rb")

non_align = pysam.AlignmentFile("non_align.bam", "wb", header = samfile.header)

for read in samfile:
    if read.is_unmapped:
        non_align.write(read)
samfile.close()
non_align.close()

total_sequence_non_alignées = 0
non_align_file = pysam.AlignmentFile("/home/theo/non_align.bam", "rb")

reference = non_align_file.references
reference_dict = {reference: i for i, reference in enumerate(reference)}

print("Index\tChromosome")
for chromosome, index in reference_dict.items():
    print(f"{index}\t{chromosome}")

for read in non_align_file:
    print(read)
    chr_name = reference[read.reference_id]
    position = read.reference_start + 1
    print(f"Chromosome: {chr_name}")
    print(f"Position: {position}")
    print(f"Non aligné: {read.is_unmapped}")
    total_sequence_non_alignées += 1
print(f"Total de sequences non alignées : {total_sequence_non_alignées}")    
non_align_file.close()
